Subject: RE: 6over4 for KAME (FreeBSD)

From: Brian Zill <[email-masked]>
Date: Fri, 27 Oct 2000 14:40:23 -0700

6to4 and 6over4, while having unfortunately similar names, are quite
different things.

6to4 is a form of automatic IPv6 tunneling over IPv4.  The IPv4 address of
the "home" end of the tunnel is encoded into the IPv6 prefix.  See
draft-ietf-ngtrans-6to4-07.txt.

6over4 is another IPv6 over "foo", where "foo" in this case is a
multicast-enabled IPv4 network, instead of say Ethernet or FDDI.  See RFC
2529.

My recollection is that an implementation of 6over4 for some BSD flavor
exists, since I recall someone performing some interoperability testing
between our implementation and that implementation.  UCLA sounds familiar.
Aren't two interoperating implementations a requirement for Proposed
Standard? (RFC 2529 is at PS) I'm not aware of any others offhand, but it
wouldn't surprise me if there were some.

--Brian

> -----Original Message-----
> From: f.johan.beisser [mailto:[email-masked]]
> Sent: Friday, 27 October, 2000 12:32
> To: Brad Huntting
> Cc: [email-masked]; [email-masked];
> [email-masked]; [email-masked]
> Subject: Re: 6over4 for KAME (FreeBSD)
> 
> 
> 
> i'm not sure if this is what you mean, but:
> 
> http://www.kfu.com/~nsayer/6to4/
> 
> also, i think that it is documented on http://www.kame.net.
> 
> of course, i oculd very well be talking out of my butt.
> 
> -- jan
> 
> 
> 
> On Fri, 27 Oct 2000, Brad Huntting wrote:
> 
> > 
> > Has anyone started writing a 6over4 (rfc2529) driver for KAME and/or
> > FreeBSD?
> > 
> > I have a pointer to a UCLA project called "Virtual Ethernet" by
> > Quang Nguyen (no email address given), but it was written for the
> > Inria stack and FreeBSD2.  If there's nothing else available, I
> > may use this as a guide.
> > 
> 
> 
> -------/ f. johan beisser /--------------------------------------+
>   http://caustic.org/~jan                      [email-masked]
>    "Never laugh at someone until you've walked a mile in their
>          shoes. Then laugh. For you are a mile away, and
>                       you have their shoes."
> 
> 
> --------------------------------------------------------------------
> IETF IPng Working Group Mailing List
> IPng Home Page:                      http://playground.sun.com/ipng
> FTP archive:                      ftp://playground.sun.com/pub/ipng
> Direct all administrative requests to [email-masked]
> --------------------------------------------------------------------
> 
--------------------------------------------------------------------
IETF IPng Working Group Mailing List
IPng Home Page:                      http://playground.sun.com/ipng
FTP archive:                      ftp://playground.sun.com/pub/ipng
Direct all administrative requests to [email-masked]
--------------------------------------------------------------------

---

From: Lixia Zhang <[email-masked]>
Date: Sat, 28 Oct 2000 06:55:45 -0700 (PDT)

> between our implementation and that implementation.  UCLA sounds

yes we did an implementation a few years back, I also recall the
interoperability test.
Someone from 3com picked up our code?
Yixin, can you recall more details?

Lixia

---

From: Francis Dupont <[email-masked]>
Date: Sat, 28 Oct 2000 18:22:50 +0200

In your previous mail you wrote:

   My recollection is that an implementation of 6over4 for some BSD flavor
   exists, since I recall someone performing some interoperability testing
   between our implementation and that implementation.

=> I did some interoperability testing at the interim meeting in Tokyo
using a 3Com multicast router (for fun!). I can remember details, only
it was very soon in the morning...

   UCLA sounds familiar.

=> I got one day the CAIRN code but when I tried to port it to FreeBSD 3.x
I discovered I had only some parts then I kept only the name (virtual
Ethernet -> vet) which is in fact the (first/only) thing needed to implement
a new flavor of IPv6 over IPv4 (I have 4 different ones :-).

=> Cisco supported this but this was removed... Obviously 6to4 (a *different*
thing) is far more popular (for bad reasons IMHO).

Regards

[email-masked]

---

From: Keith Moore <[email-masked]>
Date: Sat, 28 Oct 2000 15:00:22 -0400

> thing) is far more popular (for bad reasons IMHO).

6to4 and 6over4 solve different problems; there's very little overlap in 
their applicability.   So if there is more interest in 6to4 than 6over4 
it may be only a reflection that it is easier to upgrade a private intranet 
to support native IPv6 (thus bypassing 6over4) than to upgrade the
public Internet to support native IPv6.

Keith

---

From: Brian E Carpenter <[email-masked]>
Date: Mon, 30 Oct 2000 10:45:20 -0600

Brian,

Thnaks for clarifying that. I'm working on a whole family of specs
(6on4, 6under4, 6from4, 6and4...) to confuse everybody even more :-)

No, Proposed Standard doesn't require interoperability - that's when you go to
Draft Standard. Yes, there were a couple of implementations of 6over4 around,
but I haven't yet thought about doing the due diligence to see if we are
ready for Draft Standard. There is at least one pending change to
the 6over4 spec that we agreed on a year ago (a SHOULD NOT instead of
a MUST NOT).

6over4 is an IPNGWG item. I have deleted NGTRANS from the copies.

  Brian Carpenter

---

From: Cyndi Jung <[email-masked]>
Date: Tue, 31 Oct 2000 09:58:34 -0800

We did some interoperability testing between the UCLA code and
the Microsoft code, but we never picked up the code, and in fact
had toruble putting the UCLA software together until Yixin somehow 
put a kernel together that would work for our test.  It was a proof 
of concept, but it didn't go beyond that.  

The UCLA code was built on the Francis' stack from Inria, and I don't know
how different that is from the KAME stack. Francis had the 6over4 from UCLA
in his code when we went to Tokyo last year for the interim IPng
meeting and TAHI interoperability test - I helped him do a little
interoperability test there with Richard Draves from Microsoft, by
giving them a multi-hop IPv4 network with multicast service - it was no 
surprise to any of us that it worked, but it was nice to see.

So, Francis - you are the last person seen (by me) with a working 6over4 on
freeBSD!

Cyndi